#ifndef AARONIAHTTP_H
#define AARONIAHTTP_H

#include <QNetworkAccessManager>
#include <QNetworkReply>
#include <QNetworkRequest>
#include <QObject>
#include <QString>
#include <QJsonDocument>
#include <QJsonObject>


class AaroniaHTTP  : public QObject
{
    Q_OBJECT
public:
    AaroniaHTTP( quint32 port, QString address = "http://localhost:" );

    QNetworkReply			* StartStreaming(bool on);
    QNetworkReply			* StartRecording(bool on);

    QNetworkReply			* getHealthStatus();
    QNetworkReply			* getConfig();
    QNetworkReply			* setConfig(QJsonDocument config);

    QNetworkReply           * getDataStream( quint32 port, QString parameter = "format=raw16" );

    QNetworkReply           * HTTPGetRequest(QString endPoint);
    QNetworkReply           * HTTPPutRequest(QString endPoint, QJsonDocument data);
    QNetworkReply           * HTTPPostRequest(QString endPoint, QByteArray &data);

    QString getAddress() const;
    void setAddress(const QString &address);

    quint32 getPort() const;
    void setPort(const quint32 &port);

protected:
    QString mAddress;
    quint32 mPort;

    QNetworkAccessManager	 * mNetworkAccessManager;
};

#endif // AARONIAHTTP_H
