#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "aaroniahttp.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE


class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void on_pushButtonStart_clicked(bool checked);
    void on_pushButtonGetConfig_clicked();
    void on_pushButtonGetHealthStatus_clicked();
    void on_pushButtonSetConfig_clicked();
    void on_pushButtonGetStream1_clicked(bool checked);
    void on_pushButtonGetStream2_clicked(bool checked);
    void on_pushButtonStartRecording_clicked(bool checked);
    void on_spinBoxPort_valueChanged(int arg1);
    void on_lineEditAddress_editingFinished();

protected slots:
    void onError(QNetworkReply::NetworkError code);
    void onFinished(void);
    void onReadyRead(void);

    void onStream1Error(QNetworkReply::NetworkError code);
    void onStream1Finished(void);
    void onStream1ReadyRead(void);

    void onStream2Error(QNetworkReply::NetworkError code);
    void onStream2Finished(void);
    void onStream2ReadyRead(void);

private:
    Ui::MainWindow *ui;

    AaroniaHTTP *mRemoteMission;

    QNetworkReply *mRequest;
    QNetworkReply *mRequestStream1;
    QNetworkReply *mRequestStream2;

};
#endif // MAINWINDOW_H
